#<profile4xi profile = "02" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "rlock4xi.py">
#<abstract4xi abstract = "provides RLock4Xi class"/>
#<refer4xi reference = "synchronize.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'RLock4Xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    pass         
except:
    pass
try:                 # rare ones
    pass         
except:
    pass 
try:                 # imported-as ones 
    from time import time as _time, sleep as _sleep    
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.synchronize import RLock  
except:
    print("rlock4xi.py: *** failed in from multiprocessing.synchronize import RLock  ***")
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
import constant_family4xi
from constant_system4xi import ConstantSystem4Xi
from constant_synchronize4xi import ConstantSynchronize4Xi
from current_process4xi import get_name_current_process4xi
from examine4xi import examine4xi
from print4xi import print4xi
from reason_object4xi import reason_object4xi
from register_after_fork4xi import register_after_fork4xi
from semlock4xi import SemLock4Xi
from sense_object4xi import sense_object4xi
from time4xi import time4xi
from _cleanup4xi import _cleanup4xi
from _exit_function4xi import _exit_function4xi
from _run_after_forkers4xi import _run_after_forkers4xi 
#"
#/>

        
# =================================================================================================
#<class4xi class = "SemLock4Xi.__init__" base = "SemLock4Xi" child = "None" synopsis = "Recursive lock" usage = "
#   synchronize.py
#        Condition:
#            __init__:
#                 self._lock = lock or RLock()
#
#   arrayfunction4xi.py:
#       lock4xi = RLock4Xi()
#   condition4xi.py:
#       self._lock = lock or RLock4Xi()
#   semlock4xi.py:
#       RLock4Xi(SemLock4Xi)
#   synchronizedbase4xi.py:
#       self._lock = lock or RLock4Xi()
#   syncmanager4xi.py:
#       SyncManager4Xi.register('RLock4Xi', threading.RLock, AcquirerProxy4Xi) 
#   valuefunction4xi.py:
#       lock4xi = RLock4Xi()
#   __init__.py:
#       return RLock4Xi()
#"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
#
class RLock4Xi(SemLock4Xi):
    '''
    offers Recursive lock 
    '''
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = ('sense', 'reason', 'ace')          
    #"
    #/>
                                                                                                                                                                        
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-RLock4Xi" usage = "initializes RLock4Xi">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __init__(self):
        '''
        initializes RLock4Xi 
        '''
  
        class2print = "RLock4Xi"
        method2print = "__init__"

        message2print = "{(Step 1/8b) started" + "; init-of-RLock4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 04:20:25 04/15/13 Pacific Daylight Time
        
        message2print = "{(Step 1/8c) borning" + "; rlock2xi-of-RLock4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # 04:20:25 04/15/13 Pacific Daylight Time
                
        message2print = "{(Step 1/8d) inheriting" + "; SemLock4Xi-inheriting-by-rlock2xi-of-RLock4Xi: " + str(SemLock4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'semlock4xi.SemLock4Xi'>
        
        if examine4xi(class2print, method2print):  
        
            # -------------------------------------------------------------------------------------    
            # StepOriginal 
            # -------------------------------------------------------------------------------------             
            message2print = "{(StepOriginal) performing" + "; RLock-init-performing-by-init-of-Lock4Xi: " + str(RLock.__init__) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)           
                
                             
            RLock.__init__(self)
            
            message2print = "{(StepOriginal) performed" + "; RLock-init-performed-by-init-of-Lock4Xi: " + str(RLock.__init__) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
                        
        else:    
            cs2xi = ConstantSynchronize4Xi()
            
            message2print = "{(Step 2/8f) set" + "; cs2xi-set-by-init-of-RLock4Xi to: " + str(cs2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            # <constant_synchronize4xi.ConstantSynchronize4Xi object at 0x000000000396DF98>                
            
            recursive_semaphore2xi = cs2xi.get_recursive_mutex()            # note: this time recurvsive semaphore is give as the parameter !
            
            message2print = "{(Step 3/8b) set" + "; recursive_semaphore2xi-set-by-init-of-RLock4Xi to: " + str(recursive_semaphore2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            # 0   
            
            value2xi = cs2xi.get_sem_value()
            
            
            message2print = "{(Step 4/8b) set" + "; value2xi-set-by-init-of-RLock4Xi to: " + str(value2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            # 1      
            
            maxvalue2xi = cs2xi.get_sem_value_max()     
            
            message2print = "{(Step 5/8b) set" + "; maxvalue2xi-set-by-init-of-RLock4Xi to: " + str(maxvalue2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            # 2147483647      
            
            
            message2print = "{(Step 6/8b) informing" + "; parameter-informing-by-init-of-RLock4X: " + "* this __init__ methods does NOT take any parameters but passes to its base class using information from other modules" + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)           
                    
               
            message2print = "{(Step 7/8c) passing" + "; recursive-semaphore2xi-passing-to-SemLock4Xi-init-by-init-of-RLock4Xi: " + str(recursive_semaphore2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # 0
            
            message2print = "{(Step 7/8d) passing" + "; value2xi-passing-to-SemLock4Xi-init-by-init-of-RLock4Xi: " + str(value2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # 1
            
            message2print = "{(Step 7/8e) passing" + "; maxvalue2xi-passing-to-SemLock4Xi-init-by-init-of-RLock4Xi: " + str(maxvalue2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # 2147483647                       
                            
            SemLock4Xi.__init__(self, recursive_semaphore2xi, value2xi, maxvalue2xi)  # dragonized SemLock.__init__(self, RECURSIVE_MUTEX4XI, 1, 1) 
        
            message2print = "{(Step 7/8f) performed" + "; SemLock4Xi-init-performed-by-init-of-RLock4Xi: " + str(SemLock4Xi.__init__) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # <function SemLock4Xi.__init__ at 0x0000000003751BF8>                 
        
      
        message2print = "{(Step 8/8b) inherited" + "; SemLock4Xi-inherited-by-rlock2xi-of-RLock4Xi: " + str(SemLock4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'semlock4xi.SemLock4Xi'>
                  
        message2print = "{(Step 8/8c) activated" + "; rlock2xi-of-RLock4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 04:54:08 04/15/13 Pacific Daylight Time
                 
        message2print = "{(Step 8/8d) returning" + "; init-of-RLock4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 04:54:08 04/15/13 Pacific Daylight Time                

    #</methodize4xi>
            
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "repr-of-RLock4Xi" usage = "proxies with (self)">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/> 
    # --------------------------------------------------------------------------------------------- 
    def __repr__(self):
        '''
        RLock4Xi method __repr__: proxies with (self)
        '''
        class2print = "RLock4Xi"
        method2print = "__repr__"
        
        message2print = "{(Step 1/3a) started" + "; repr-of-RLock4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 04:37:06 04/15/13 Pacific Daylight Time
        
        if examine4xi(class2print, method2print):  
        
            # -------------------------------------------------------------------------------------    
            # StepOriginal
            # -------------------------------------------------------------------------------------             
            message2print = "{(StepOriginal) performing" + "; RLock-repr-performing-by-init-of-Lock4Xi: " + str(RLock.__repr__) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)           
                
                             
            return RLock.__repr__(self)
     
        else:  
             
            message2print = "{(Step 1/3b) trying" + "; setting-trying-by-repr-of-RLock4Xi: " + "name2xi and count2 setting trying"  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)         
            # 04:37:06 04/15/13 Pacific Daylight Time               
            
     
            try:
                if self._semlock._is_mine():
                                              
                    name2xi = get_name_current_process4xi()
                    
                    message2print = "{(Step 2/3a) set" + "; name2xi-set-by-repr-of-RLock4Xi to: " + str(name2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                    # None 
                                    
                    if threading.current_thread().name != 'MainThread':
                        name2xi += '|' + threading.current_thread().name
                    
                        message2print = "{(Step 2/3b) set" + "; name2xi-set-by-repr-of-RLock4Xi to: " + str(name2xi)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)    
                           
                        
                    count2xi = self._semlock._count()
                    
                    message2print = "{(Step 2/3c) set" + "; count2xi-set-by-repr-of-RLock4Xi to: " + str(count2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                       
                    
                elif self._semlock._get_value() == 1:
                    # -------------------------------------------------------------------------------------------------------------------------------------------
                    message2print = "{(Step 2/3) stepping" + "; (Step 2/3)-stepping-by-repr-of-RLock4Xi: " + "~ semlock value was 1 ~"  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # -------------------------------------------------------------------------------------------------------------------------------------------
                                       
                    name2xi, count2xi = 'None', 0
                    
                    message2print = "{(Step 2/3d) set" + "; name2xi-set-by-repr-of-RLock4Xi to: " + str(name2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                    # None
                    
                    message2print = "{(Step 2/3e) set" + "; count2xi-set-by-repr-of-RLock4Xi to: " + str(count2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                    # 0      
                    
                elif self._semlock._count() > 0:
                    # -------------------------------------------------------------------------------------------------------------------------------------------
                    message2print = "{(Step 2/3) stepping" + "; (Step 2/3)-stepping-by-repr-of-RLock4Xi: " + "~ semlock count > 0 ~"  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # -------------------------------------------------------------------------------------------------------------------------------------------
                                       
                    name2xi, count2xi = 'SomeOtherThread', 'nonzero'
                    
                    message2print = "{(Step 2/3f) set" + "; name2xi-set-by-repr-of-RLock4Xi to: " + str(name2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                    
                    message2print = "{(Step 2/3g) set" + "; count2xi-set-by-repr-of-RLock4Xi to: " + str(count2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                     
                    
                else:
                    # -------------------------------------------------------------------------------------------------------------------------------------------
                    message2print = "{(Step 2/3) stepping" + "; (Step 2/3)-stepping-by-repr-of-RLock4Xi: " + "~ the last choice  ~"  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # -------------------------------------------------------------------------------------------------------------------------------------------
                                       
                    name2xi, count2xi = 'SomeOtherProcess', 'nonzero'
                    
                    message2print = "{(Step 2/3h) set" + "; name2xi-set-by-repr-of-RLock4Xi to: " + str(name2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                    
                    message2print = "{(Step 2/3i) set" + "; count2xi-set-by-repr-of-RLock4Xi to: " + str(count2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                          
                    
            except Exception:
                # -------------------------------------------------------------------------------------------------------------------------------------------
                message2print = "{(Step 2/3) stepping" + "; (Step 2/3)-stepping-by-repr-of-RLock4Xi: " + "~ Exception ~"  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # -------------------------------------------------------------------------------------------------------------------------------------------
                                   
                message2print = "{(Step 2/3j) hit" + "; exception-hit-by-repr-of-RLock4Xi: " + " *** failed to set name2xi and count2xi *** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                        
                      
                
                name2xi, count2xi = 'unknown', 'unknown'
                
                    
                message2print = "{(Step 2/3k) set" + "; name2xi-set-by-repr-of-RLock4Xi to: " + str(name2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                   
                    
                message2print = "{(Step 2/3l) set" + "; count2xi-set-by-repr-of-RLock4Xi to: " + str(count2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
           
                   
            r2xi = '<RLock4Xi(%s, %s)>' % (name2xi, count2xi)    
        
            
            message2print = "{(Step 3/3b) returning" + "; r2xi-returning-by-repr-of-RLock4Xi: " + str(r2xi) + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)    
            # <RLock4Xi(None, 0)>
                                   
            return r2xi        
    #</methodize4xi>
                                           
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-RLock4Xi" usage = "senses RLock4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        senses RLock4Xi class objects
        '''
        
        
        class2print = 'RLock4Xi'
        method2print = 'sense'
        
        
        message2print = "{started" + "; sense-of-RLock4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
  
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; RLock4Xi-sensing-by-sense-of-RLock4Xi: " + str(RLock4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                       
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-RLock4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['semlock-of-rlock2xi'] = str(self._semlock)     
            kb2xi['mine-of-rlock2xi'] = self._semlock._is_mine() 
            kb2xi['lock-of-rlock2xi'] = self._semlock._get_value()
            kb2xi['count-of-rlock2xi'] = self._semlock._count()                        
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-RLock4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
        message2print = "{sensed" + "; RLock4Xi-sensed-by-sense-of-RLock4XiZ " + str(RLock4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
   
   
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-RLock4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                            
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-RLock4Xi" usage = "reasons RLock4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        reasons RLock4Xi class objects
        '''
        
        
        class2print = 'RLock4Xi'
        method2print = 'reason'

        
        message2print = "{started" + "; reason-of-RLock4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
       
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; RLock4Xi-reasoning-by-sense-of-RLock4Xi: " + str(RLock4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{got" + "; kb4xi-got-by-sense-of-RLock4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)              
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['functions-of-rlock2xi'] = str(1)     
            kb4xi['attributes-of-rlock2xi'] = str(3)
        except:
            message2print = "{yielded" + "; kb4xi-yielded-by-sense-of-RLock4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
              
        
          
        
        message2print = "{reasoned" + "; RLock4Xi-reasoned-by-sense-of-RLock4Xi: " + str(RLock4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-sense-of-RLock4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                  
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-RLock4Xi" usage = "aces RLock4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        aces RLock4Xi class objects 
        '''
           
        
        
        class2print = 'RLock4Xi'
        method2print = 'ace'
        
        
        message2print = "{started" + "; ace-of-RLock4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; RLock4Xi-acing-by-ace-of-RLock4Xi: " + str(RLock4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                 
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-RLock4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------              
        try:
            kb8xi['depencies-of-rlock2xi'] = str(4)     
        except:
            message2print = "{yielded" + "; kb8xi-yielded-by-ace-of-RLock4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        message2print = "{aced" + "; RLock4Xi-aced-by-ace-of-RLock4Xi: " + str(RLock4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-RLock4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                   
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of rlock4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

